#include <LCD.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3F, 2, 1, 0, 4, 5, 6, 7);
#define SDA PIN_PC4
#define SCL PIN_PC5
#define trig_out PIN_PC0
#define echo_out PIN_PC1
#define trig_in PIN_PC2
#define echo_in PIN_PC3
#define fan_a PIN_PB1
#define fan_b PIN_PB0
#define sw_auto PIN_PB2
#define sw_on PIN_PB3
byte people[] = {
  B01110,
  B01110,
  B01110,
  B00100,
  B11111,
  B00100,
  B01010,
  B10001
};

float find_length(int trig ,int echo) {
  digitalWrite(trig, LOW);
  delayMicroseconds(5);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);
  float duration = pulseIn(echo, HIGH);
  return (duration / 2) / 29.1;
  
}
void setup()
{
  lcd.begin(16, 2);
  lcd.createChar(0, people);
  lcd.setBacklightPin(3, POSITIVE);
  lcd.setBacklight(HIGH);
  lcd.setCursor(0, 0);
  lcd.print("HELLO");
  pinMode(trig_out, OUTPUT);
  pinMode(echo_out, INPUT);
  pinMode(trig_in, OUTPUT);
  pinMode(echo_in, INPUT);
  pinMode(fan_a, OUTPUT);
  pinMode(fan_b, OUTPUT);
  pinMode(sw_auto, INPUT_PULLUP);
  pinMode(sw_on, INPUT_PULLUP);

}
long duration_outter , duration_inner , cm_outter , cm_inner;
int count = 0;
unsigned long time_now = 0;
bool is_auto = true, is_on = true;
float dust_density=150;
bool plus = true;
void loop()
{
  lcd.clear();
  float inner = find_length(trig_in,echo_in);
  float outter = find_length(trig_out,echo_out);
  if(outter <= 5) {
    time_now = millis();
    while (millis() < time_now+2000){
      ;
    }
    while (millis() < time_now+6000) {
      inner = find_length(trig_in,echo_in);
      if ((inner <= outter +1) && (inner >= outter - 1)) {
        lcd.clear();
        lcd.setCursor(5,0);
        lcd.print("WELCOME");
        delay(500);
        count += 1;
        break;
      }
    }
  }
  else if (inner <= 5){
    time_now = millis();
    while (millis() < time_now+2000){
      ;
    }
    while (millis() < time_now+6000) {
      outter = find_length(trig_out,echo_out);
      if ((outter <= inner + 1) && (outter >= inner - 1)) {
        lcd.clear();
        lcd.setCursor(5,0);
        lcd.print("GOODBYE");
        delay(500);
        count -= 1;
        break;
      }
    }
  }
  if(!digitalRead(sw_auto)){
    is_auto = !is_auto;
    is_on = !is_on;
  }
  if(!digitalRead(sw_on) && sw_auto){
    is_on = !is_on;
    is_auto = false;
  }
  else if (!digitalRead(sw_on) && !sw_auto){
    is_on = !is_on;
  }
  if (is_auto) {
    if (count >= 1 && dust_density >= 90) {
      digitalWrite(fan_a,HIGH);
      digitalWrite(fan_b,LOW);
      is_on = true;
    }
    else {
      digitalWrite(fan_a,LOW);
      digitalWrite(fan_b,LOW);
      is_on = false;
    }
  }
  else {
    if (is_on) {
      digitalWrite(fan_a,HIGH);
      digitalWrite(fan_b,LOW);
    }
    else {
      digitalWrite(fan_a,LOW);
      digitalWrite(fan_b,LOW);
    }
  }
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.write(byte(0));
  lcd.setCursor(1,0);
  lcd.print("=");
  lcd.setCursor(2,0);
  lcd.print(count);
  lcd.setCursor(5,0);
  lcd.print("PM2.5=");
  lcd.setCursor(11,0);
  lcd.print(dust_density);
  lcd.setCursor(0,1);
  if (is_auto) {
    lcd.print("AUTO");
  }
  else {
    lcd.print("MANUAL");
  }
  lcd.setCursor(13,1);
  if (is_on) {
    lcd.print("ON");
  }
  else {
    lcd.print("OFF");
  }
  if (dust_density == 30) {
    plus = true;
  }
  else if (dust_density == 150) {
    plus = false;
  }
  if (plus){
    dust_density += 1;
  }
  else {
    dust_density -= 1;
  }
  delay(250);
}
